
TYPO3.Flow - Feature # 29547

Status: Resolved Priority: Should have
Author: Torsten no-lastname-given Category: Persistence
Created: 2011-09-07 Assigned To: Christian Müller
Updated: 2012-05-03 Due date:
PHP Version:
Has patch: No
Complexity:
Subject: @identity should make property unique in Database
Description

A Property with the @indentify annotation is currently not unique in the database.

So you could for example add 2 accounts with the same accountIdentifier. That shouldn't work.

Subtasks:
Bug # 36717: Remove Identity from Resource Resolved
Related issues:
related to TYPO3.Flow - Feature # 30933: Check for unique constraints on add() Needs Feedback2011-10-14
related to TYPO3.Party - Bug # 37266: Duplicate email address throws exception Resolved 2012-05-17
related to TYPO3.Flow - Bug # 9557: It's possible to persist multiple entitie... Rejected 2010-09-01
related to TYPO3.Flow - Bug # 32823: Make combination of Account identifier a... Resolved 2011-12-23

Associated revisions
Revision b0fb449c - 2012-05-03 09:31 - Christian Müller

[FEATURE] Identity annotation should make properties unique

With this change all properties annotated with the Identity
annotation will be added to an unique constraint in the database.

Change-Id: Ief9455e10c58f999cf46e0586e632ff3e2ef9ad5
Resolves: #29547
Releases: 1.1

Revision a788b292 - 2012-05-03 15:58 - Karsten Dambekalns

[TASK] Fix schema migrations adding useless unique indexes

This change removes the index creation commands on the Role table from
the migrations supplied with Ief9455e10c58f999cf46e0586e632ff3e2ef9ad5,
as the involved field is the primary key (and thus a unique index) anyway.

Change-Id: I7280a5f5265109cea8ef110c399c5b76563c4b03
Related: #29547

History
#1 - 2011-09-09 21:37 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow
#2 - 2011-09-09 21:37 - Karsten Dambekalns
- Category set to Persistence

#3 - 2011-09-19 13:30 - Karsten Dambekalns
- Assigned To set to Karsten Dambekalns

#4 - 2012-03-14 15:20 - Christian Müller
- Status changed from New to Accepted
- Assigned To changed from Karsten Dambekalns to Christian Müller
- Has patch set to No

#5 - 2012-03-14 15:21 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#6 - 2012-03-14 16:01 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#7 - 2012-03-14 16:02 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#8 - 2012-03-30 13:39 - Adrian Föder

User Kirab mentioned there were "problems with Resource system"; I assume it's the problem that duplicate \TYPO3\FLOW3\Resource\Resource
records may occur, the identities are the following:

 1    /**
 2     * @var \TYPO3\FLOW3\Resource\ResourcePointer
 3     * @ORM\ManyToOne
 4     * @FLOW3\Identity
 5     */
 6    protected $resourcePointer;
 7
 8    /**
 9     * @var string
10     * @FLOW3\Validate(type="StringLength", options={ "maximum"=100 })
11     * @FLOW3\Identity
12     */
13    protected $filename = '';
14
15    /**
16     * @var string
17     * @FLOW3\Validate(type="StringLength", options={ "maximum"=100 })
18     * @FLOW3\Identity
19     */
20    protected $fileExtension = '';

If you upload the exact same file with the same filename, a violation will occur because the same key emerges.
(the ResourcePointer, on the other hand, is intended to be there only once for the same file (content => SHA1).

I would even say the same goes for a Resource: if a Resource has the same filename, extension and ResourcePointer, it is the exact same file and no
need for an additional recordset...

If not, or if there should me multiple recordsets for a same file (e.g. for separating ownership etc), the identity must then be a UUID, like usual. I can't
see anything more that intrinsically makes a file representation unique than the name, the content and the extension...

#9 - 2012-04-29 22:34 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#10 - 2012-04-30 10:53 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#11 - 2012-04-30 10:56 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#12 - 2012-04-30 10:58 - Karsten Dambekalns
- Target version set to 1.1

The full stack of changes can be found at https://review.typo3.org/#/q/topic:29547-unique-identity,n,z

#13 - 2012-04-30 12:35 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#14 - 2012-04-30 12:41 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#15 - 2012-04-30 12:46 - Gerrit Code Review
Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#16 - 2012-04-30 13:02 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#17 - 2012-04-30 13:04 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#18 - 2012-04-30 16:04 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#19 - 2012-04-30 16:05 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#20 - 2012-04-30 21:29 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#21 - 2012-05-03 09:15 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#22 - 2012-05-03 09:31 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9647

#23 - 2012-05-03 14:40 - Christian Müller
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:b0fb449cc9dc7266fd027b2c3618041e6fad3ef7.
